<bugID>1134222<Summary>[e10s] "Save Link As..."/"Bookmark This Link" in remote browser causes unsafe CPOW usage warning</Summary><Description>+++ This bug was initially created as a clone of Bug #1133577 +++

STR:

1) Visit a site with some links on it in an e10s window
2) Right-click on a link, and choose "Save Link As..."

This causes some "unsafe CPOW usage" warnings in the Browser Console.

In browser/base/content/nsContextMenu.js:

  // Save URL of clicked-on link.
  saveLink: function() {
    var doc =  this.target.ownerDocument; &lt;-- Causes CPOW warning
    var linkText;
    // If selected text is found to match valid URL pattern.
    if (this.onPlainTextLink)
      linkText = this.focusedWindow.getSelection().toString().trim();
    else
      linkText = this.linkText();
    urlSecurityCheck(this.linkURL, this.principal);

    this.saveHelper(this.linkURL, linkText, null, true, doc);
  },


in browser/base/content/utilityOverlay.js:

// Gather all descendent text under given document node.
function gatherTextUnder ( root ) 
{
  var text = "";
  var node = root.firstChild; &lt;-- Causes CPOW warning
  var depth = 1;
  while ( node &amp;&amp; depth &gt; 0 ) {
    // See if this node is text.
    if ( node.nodeType == Node.TEXT_NODE ) { &lt;-- Causes CPOW warning
      // Add this text to our collection.
      text += " " + node.data; &lt;-- Causes CPOW warning
    } else if ( node instanceof HTMLImageElement) { &lt;-- Causes CPOW warning [complex, image]
      // If it has an "alt" attribute, add that.
      var altText = node.getAttribute( "alt" ); &lt;-- Causes CPOW warning [image]
      if ( altText &amp;&amp; altText != "" ) {
        text += " " + altText;
      }
    }
    // Find next node to test.
    // First, see if this node has children.
    if ( node.hasChildNodes() ) { &lt;-- Causes CPOW warning
      // Go to first child.
      node = node.firstChild; &lt;-- Causes CPOW warning [complex]
      depth++;
    } else {
      // No children, try next sibling (or parent next sibling).
      while ( depth &gt; 0 &amp;&amp; !node.nextSibling ) { &lt;-- Causes CPOW warning
        node = node.parentNode; &lt;-- Causes CPOW warning
        depth--;
      }
      if ( node.nextSibling ) { &lt;-- Causes CPOW warning
        node = node.nextSibling; &lt;-- Causes CPOW warning [complex]
      }
    }
  }
  // Strip leading and tailing whitespace.
  text = text.trim();
  // Compress remaining whitespace.
  text = text.replace( /\s+/g, " " );
  return text;
}

note that the amount of warnings depends on the structure of the link, and I've marked up accordingly
untagged warnings are just caused by &lt;a&gt;text&lt;/a&gt;
[complex] tagged warnings are caused by e.g. &lt;a&gt;&lt;em&gt;text&lt;/em&gt; text&lt;/a&gt;
[image] tagged warnings are caused by e.g. &lt;a&gt;&lt;img/&gt;&lt;/a&gt;


Note I might make this situation even worse in bug 850378</Description></bugID>